import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.rms.*;
import java.util.*;
import java.io.*;


public class Monitor extends MIDlet
{ 
    static Command QUIT_CMD = new Command("Quit", Command.EXIT, 4);
    static Command BACK_CMD = new Command("Back", Command.BACK, 2);
    static Command STOP_CMD = new Command("Stop", Command.BACK, 1);
    static Command NEW_CMD = new Command("New", Command.SCREEN, 1);
    static Command RESET_CMD = new Command("Reset", Command.SCREEN, 1);
    static Command HELP_CMD = new Command("Help", Command.SCREEN, 3);

    static final int MAX_STEPS = 10;

    RecordStore store;
    State       state;

    static class State { 
        long[] elapsedTime = new long[MAX_STEPS];
        int    nSteps;
        long   startTime;
        int    currentStep = -1;
        
        byte[] pack() { 
            try { 
                ByteArrayOutputStream aout = new ByteArrayOutputStream();
                DataOutputStream out = new DataOutputStream(aout);
                out.writeInt(nSteps);
                out.writeInt(currentStep);
                out.writeLong(startTime);
                for (int i = 0; i < nSteps; i++) { 
                    out.writeLong(elapsedTime[i]);
                }
                out.close();
                return aout.toByteArray();
            } catch (IOException x) {
                return null;
            }
        }

        void unpack(byte[] record) { 
            try {
                DataInputStream in = new DataInputStream(new ByteArrayInputStream(record));
                nSteps = in.readInt();
                currentStep = in.readInt();
                startTime = in.readLong();
                for (int i = 0; i < nSteps; i++) { 
                    elapsedTime[i] = in.readLong();
                }
            }  catch (IOException x) {}
        }
    }



    private void openStore() {
        try { 
            store = RecordStore.openRecordStore("MONITOR102", true);
            if (store.getNumRecords() > 0) { 
                state.unpack(store.getRecord(1));
            } else { 
                byte[] record = state.pack();
                store.addRecord(record, 0, record.length);
            }
        } catch(Exception x) { 
        }
    }

    void flushStore() 
    { 
        if (store != null) {
            try { 
                byte[] record = state.pack();
                store.setRecord(1, record, 0, record.length);
            } catch (Exception x) {}
        }
    }

    private void closeStore() 
    {
        if (store != null) { 
            try { 
                store.closeRecordStore();
                store = null;
            } catch (Exception x) {}
        }
    }

    public Monitor() {  
        state = new State();
        openStore();        
    }
    
    protected void destroyApp(boolean unconditional) {
        flushStore();
        closeStore();
    }    

    protected  void pauseApp() {
        flushStore();
    }

    protected void startApp() 
    {
        new MonitorCanvas(this);
    }

    void quit() { 
        destroyApp(true);
        notifyDestroyed();
    }
}
